<?php

      function generateEdz($imagePath, $dest, $containerPath, $uid): void
      {
          $dziFolder = $uid.'_files';  
          // Generate 256 tiles.
          exec("vips dzsave \"$imagePath\" \"$dest/$uid\" --tile-size 256 --overlap 0 --properties=true");
          dzi2Edz("$dest/$dziFolder", "$dest/$uid.dzi");
  
          // Cleanup
          mkdir("$containerPath/edz");
          rename("$dest/$uid.zip", "$containerPath/edz/edz.zip");
          rename("$dest/$uid.json", "$containerPath/edz/edz.json");

      }
  
      function dzi2Edz($dirName, $dziFile) {
          $parDir = dirname($dirName);
          $zipFile = basename($dirName);
          $dom = new \DOMDocument();
          $dom->load($dziFile);
          $imageTag = $dom->getElementsByTagName('Image')[0];
          $sizeTag = $dom->getElementsByTagName('Size')[0];
          $cleanFile = str_replace("_files", "", $zipFile);
          $zipFile = $cleanFile . ".zip";
  
          $fileTable = [
              "Image" => [
                "TileFormat" => "edz",
                "Format" => $imageTag->getAttribute('Format'),
                "Overlap" =>  $imageTag->getAttribute('Overlap'),
                "TileSize" => $imageTag->getAttribute('TileSize'),
                "Size" => [
                  "Height" => $sizeTag->getAttribute('Height'),
                  "Width" =>  $sizeTag->getAttribute('Width')
                ],
                "ZipFile" => "edz.zip",
                "Ranges" => []
              ]
            ];
  
          chdir($parDir);
          exec("rm ./" . basename($dirName) . "/vips-properties.xml");
          exec("mkdir $cleanFile && cp -r ./" . basename($dirName) . " ./$cleanFile");
          exec("zip -Z store -r $zipFile ./$cleanFile");
          $fileContents = file_get_contents($zipFile);
  
          $zip = new \ZipArchive();
          $zip->open($zipFile);
          for ($i = 0; $i < $zip->numFiles; $i++) {
            $file = $zip->statIndex($i);
            if (!preg_match('/\/$/', $file['name'])) {
              $data = $zip->getFromName($file['name']);
              $offset = strpos($fileContents, $data);
              $size = strlen($data);
              $tableFilename = str_replace($cleanFile, 'edz', $file['name']);
              $fileTable["Image"]["Ranges"][$tableFilename] = [
                "offset" => $offset,
                "size" => $size
              ];
            }
          }
          $zip->close();
  
          $json = json_encode($fileTable);
          file_put_contents(str_replace("_files", "", $dirName)  . ".json", $json);
          exec("rm -rf $cleanFile");
          exec("rm -rf $dirName");
          exec("rm -rf $dziFile");
      }

if ($argc < 5) {
    echo "Usage: php cli_tool.php <imagePath> <dest> <containerPath> <uid>\n";
    exit(1);
}

$imagePath = $argv[1];
$dest = $argv[2];
$containerPath = $argv[3];
$uid = $argv[4];

generateEdz($imagePath, $dest, $containerPath, $uid);


